global ConvertLog=#()as string	
global ConverFinish
global MissMaps=#()
global MissVrayProxy=#()
global lab_text
global item_text=#()
global err

Struct MissBmp
(
	fn MissRefresh_Bitmap =
	(
		Amaps=#()
		MissMaps=#()
			Amaps=getclassinstances bitmaptexture
			for m in 1 to amaps.count do 
			(
				if Amaps[m].filename!=undefined then
				(
					if DoesFileExist Amaps[m].filename==false then
						--tt=getfilenamefile Amaps[m].filename+getfilenametype Amaps[m].filename
						--append MissMaps tt
						append MissMaps  Amaps[m].filename
					)
				
			)
			MissMaps=makeUniqueArray MissMaps
		),
	fn MissRefresh_VrayProxy =
	(	
			-----------------------
			MissVrayProxy=#()
			Aproxy=getclassinstances vrayproxy
			for m in 1 to Aproxy.count do 
			(
				if DoesFileExist Aproxy[m].filename==false then
				(
					--tt=getfilenamefile Aproxy[m].filename+getfilenametype Aproxy[m].filename
					
					--append MissVrayProxy tt
					append MissVrayProxy Aproxy[m].filename
					)
				)
			MissVrayProxy=makeUniqueArray MissVrayProxy
			
					
		),
	fn MissRefresh_VrayHDRI =
	(
		MissVrayHDRI=#()
		AHDRI=getclassinstances vrayhdri
		for m in 1 to AHDRI.count do 
		(
			if DoesFileExist AHDRI[m].HDRIMapName==false then
				(
					--tt=getfilenamefile AHDRI[m].HDRIMapName+getfilenametype AHDRI[m].HDRIMapName
					--append MissVrayHDRI tt
					append MissVrayHDRI AHDRI[m].HDRIMapName
					)
				)
			MissVrayHDRI=makeUniqueArray MissVrayHDRI
			
		
		),
	fn MissRefresh_IESWebFile =
	(
		MissIESWebFile=#()
		AIESWebFile=getclassinstances target_Light
		for m in 1 to AIESWebFile.count do 
		(
			if DoesFileExist AIESWebFile[m].webfile==false then
				(
					--tt=getfilenamefile AiesWebFile[m].webfile+getfilenametype AiesWebFile[m].webfile
					--append MissIESWebFile tt
					append MissIESWebFile AiesWebFile[m].webfile
					)
				)
			MissIESWebFile=makeUniqueArray MissIESWebFile
			
		
		)
)
--------------------------------------------------------------------
Struct ChMappingDictStruct 
(
	self = DotNetObject "System.Collections.Generic.Dictionary`2[System.String,System.String]"
	,
	Fn Add inputKey inputValue = 
	(
		try
		(
			self.Add inputKey inputValue
		)
		catch
		(
			print (GetCurrentException() + "  ||  " + inputKey as string)
		)
	)
	,
	Fn Get inputKey = 
	(
		local result
		try	(result = self.Item inputKey )catch()
		result
	)
)
Fn GetMD5 = 
(
	
	)
Fn SetDirectoryAccessControlType inputDirectoryInfo = 
(   tempUserName = (DotNetClass "System.Environment").UserName    
	fileSystemRights = (DotNetClass "System.Security.AccessControl.FileSystemRights").Modify    
	accessControlType = (DotNetClass "System.Security.AccessControl.AccessControlType").Allow    
	fileSystemAccessRule = DotNetObject "System.Security.AccessControl.FileSystemAccessRule"tempUserName fileSystemRights accessControlType     
	directorySecurity = inputDirectoryInfo .GetAccessControl()    
	--directorySecurity.AddAccessRule fileSystemAccessRule     
	inputDirectoryInfo.SetAccessControl directorySecurity 
	)

Fn GetAllFiles targetPath fileFilter  =
(   local SearchOption,DotNetDirectoryInfo    
	SearchOption = DotNetClass "System.IO.SearchOption"    
	DotNetDirectoryInfo = DotNetObject "System.IO.DirectoryInfo" targetPath    
	SetDirectoryAccessControlType DotNetDirectoryInfo    
	result = for tfi in (DotNetDirectoryInfo.GetFiles fileFilter SearchOption.AllDirectories) collect tfi.FullName    
	result
	)
Fn GetNoneSubFolderFiles targetPath fileFilter =
(
	a=targetPath+fileFilter
	files = getFiles a
	files

	)
-----------------------------------
fn UpdateMissMaps =
(
	a=#()
	b=#()
	c=#()
	d=#()
	lab_text=""
	item_text=""
	try(a=MissBmp.MissRefresh_Bitmap())catch()
	try(b=MissBmp.MissRefresh_VrayProxy())catch()
	try(c=MissBmp.MissRefresh_VrayHDRI())catch()
	try(d=MissBmp.MissRefresh_IESWebFile())catch()
	lab_text="Lost Bitmap"+a.count as string +"Vary proxy"+ b.count as string+"HDRI"+c.count as string+"Photometric Web"+d.count as string
	lab_text=lab_text as string
	
	local l="------------------------------------------"
	append a l
	a=a+b
	append a l
	a=a+c
	append a l
	a=a+d
	local tt=#()
	local t1=""
	for i in 1 to a.count do 
	(
		if a[i]==l then
		(
			tt=append tt l
			)
		else
		(
			t1=getfilenamefile a[i]+getfilenametype a[i]
			tt=append tt t1
			)
		)
	item_text= tt
	
				
	
	)
---------------------
fn Fntest =
(
	
	messagebox "Fntest!!!!!!"
	
	)

--Ƚļ
fn CompareFiles file_1 file_2=
(
	temp=false
	f1=fopen file_1 "rb"
	f1=ReadByte f1
	f2=fopen file_2 "rb"
	f2=ReadByte f2
	if f1==f2 then
	( 
		temp=true
		)
	else
	(
		temp=false
		)
	return temp
	fclose f1
	fclose f2
	)
----sub
fn CompareTexture_Sub file_1 file_2=
(
	local f1=""
	local f2=""
	file_1=replaceChar file_1 "\\" "\\\\"
	file_2=replaceChar file_2 "\\" "\\\\"
	temp=false
	f1=getFileSize file_1
	f2=getFileSize file_2
	if f1==f2 then
	( 
		temp=true
		)
	else
	(
		temp=false
		)
	fclose f1
	fclose f2

	return temp
	
	)
fn CompareTexture file_1 file_2=
(
	local f1=""
	local f2=""
	--file_1=replaceChar file_1 "\\" "\\\\"
	--file_2=replaceChar file_2 "\\" "\\\\"
	temp=false
	f1=getfilesize file_1
	f2=getfilesize file_2
	if f1==f2 then
	( 
		temp=true
		)
	else
	(
		temp=false
		)
	fclose f1
	fclose f2
	return temp
	
	)
--fn ʾʧͼϢ
-- A function used to modify file names containing '\' to "\\"
fn replaceChar str oChar rChar = 
(
	local tStr = ""
	for i in 1 to str.count do
	(
		if str[i]==oChar then
		(
			tStr=tStr+rChar
			)
		else
		(
			tStr=tStr+str[i]
			)
		)
	tStr
	)



fn SearchFiles Old New=
(
	
	
	)
	-----------------------------------------------------
fn CollectVrayProxy t=
(	
	Vray_Proxy=getclassinstances vrayproxy
		for m in 1 to vray_proxy.count do 
		(
			lbl_Process.text="Collecting Vray Proxy..."
			messagebox vray_proxy[m].filename
			)
	)
	-------------------------------------------------
fn AddConertLog old new=
(
	local c=""
	local i
	c=old+"=======>>>>>>"+new
	i=1
	append ConvertLog[i] c
	
	)
-------fnдת־
fn WriteLog old new=
(
	local i
	local c=""
	Ofile=GetFilenamePath(GetSourceFileName())+"Covert.Log"
	f= openfile Ofile mode:"a+"
	c=old+"=======>>>>>>"+new
	try(format "%\n" c to:f)catch()
	close f
			
	)



rollout Tools_A "WMagicTools1.5.6" width:624 height:432
(
	
	button btn3 "Material change map" pos:[16,21] width:64 height:20 toolTip:"Material change map"
	GroupBox grp3 "Shader renamed" pos:[8,5] width:80 height:64 toolTip:"Shader renamed"
	button btn7 "map change Material" pos:[16,45] width:64 height:20 toolTip:"map change Material"
	GroupBox grp6 "Naming objects" pos:[96,5] width:104 height:64 toolTip:"Naming objects"
	button btn16 "objects change Material" pos:[104,21] width:88 height:20 toolTip:"objects change Material"
	button btn17 "Own naming facility" pos:[104,45] width:88 height:20 toolTip:"Own naming facility"
	button btn30 "Dictionary" pos:[16,160] width:63 height:18 toolTip:"Check whether the missing characters in the dictionary~"
	button btn_Collect_Browser "path" pos:[16,240] width:48 height:16
	button tt "Start " pos:[88,160] width:56 height:19 toolTip:"Start Conversion"
			
			
	edittext edt_Collect_Text "" pos:[16,216] width:176 height:16
	
	progressBar EN_pb1 "probar" pos:[15,368] width:179 height:12 enabled:true value:0 color:(color 255 0 0) orient:#horizontal
	GroupBox grp4 "Map renamed" pos:[8,80] width:192 height:104
	progressBar EN_pb2 "probar" pos:[16,384] width:179 height:12 enabled:true value:0 color:(color 184 238 107) orient:#horizontal
	----------------------------------------------------------------------------------------------
	button btn41 "Collect" pos:[72,240] width:46 height:16 enabled:true
	Timer tmr1 "Timer" pos:[256,248] width:24 height:24
	---------------------------------------------------------------------------------------

	edittext edt_R_FilePath "" pos:[16,96] width:136 height:16
	button btn_R_Browse "path" pos:[160,96] width:32 height:16
	GroupBox grp16 "Select the object map collection" pos:[8,192] width:192 height:72
	------------------------------------------------------

	button btn67 "About" pos:[208,352] width:71 height:16
	button btn68 "Help" pos:[288,352] width:64 height:16
	button Collect_Map "Collection" pos:[128,320] width:56 height:15
	label lbl1 "CopyRight@StarLight2016" pos:[248,400] width:129 height:16
	--ĸƴļ
    on btn68 pressed do
	(	ShellLaunch "http://www.scriptsays.com/ """
		)
		
-----------------------------------------------------------------
-----------------------------------------------------------------
		
-------------------------------------------
	-------------------------------------
	----------------------------------------------ռѡģͼ---------------------------
	
	

			
			
		
		
	---------------------------------------------------------------------ռѡ-------------------------------
	label lbl_Process "" pos:[15,400] width:176 height:16
	GroupBox grp9 "Rapid collection and specify" pos:[8,280] width:191 height:80
	edittext edt_Bmp "" pos:[16,296] width:175 height:16
	---
	
	---------------------------------------------------------------

	
	button BMP_B "path" pos:[16,320] width:48 height:16
	button BMP_A "Designation" pos:[72,320] width:46 height:16 enabled:true
-----------------------------------------ָͼ----------------------------


-----------------------------------------------------------------

	
---------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------

	button btn_MissRefresh "Refresh" pos:[216,328] width:47 height:12 toolTip:"Refresh map~"
	
	label Lbl_MissFiles "" pos:[208,6] width:184 height:32
	button btn_MissSearch "Search" pos:[272,328] width:48 height:13
	
	
------------------------------------------------------

		
	button btn_MissBrowser "path" pos:[352,304] width:40 height:16
	edittext edt_MissBrowser "" pos:[208,304] width:136 height:16
	listbox MissList "" pos:[208,40] width:184 height:17
	------------------------------

	-----------------=-----------------
	
	---------------------------------ˢ¶ʧͼ---------------------------
	-----------------------------------------------------------

	checkbox chk_subFolder "Subfolders" pos:[326,328] width:64 height:16 checked:true
	
--------------------fn---------------------		
fn ResizeForm=
(
	MissList.height=2400
	messagebox "afs"
	)
---------------------------------------------------	
	----------------------------------------------------------
	checkbox chk_enbitmap "bitmap" pos:[16,120] width:45 height:16 checked:true
	-------------------------------------------------------
	checkbox chk_enproxy "proxy" pos:[64,120] width:44 height:16 checked:true
	checkbox chk_enies "Photometric" pos:[108,120] width:46 height:16 checked:true
	checkbox chk_enhdri "HDRI" pos:[152,120] width:41 height:16 checked:true
	checkbox chk_b_subFolder "folder" pos:[15,338] width:70 height:13 checked:true
	----------------------------------------------------------
	--------------------------------------------------------------------
	checkbox chk_EnSubFolder "folder" pos:[16,140] width:70 height:13 checked:true
		
	--ˢ¶ʧͼ~
	--˫ʧͼϢ~

	--ռͼ~
	--------------------------------------------------------------------
--¼~

	--ͼϢ

	--ڴС
	Timer tmr2 "Timer" pos:[481,295] width:24 height:24
	
	---------------------ڸ¼----------------------------------------

	---------------------------------------------------------

	on Tools_A open do
	(
	
		UpdateMissMaps()
		Lbl_MissFiles.text=lab_text
		MissList.items= item_text
		MissList.height=240
	
		)
	on btn3 pressed do
	(
		--֧ max׼ʡVRay׼ʡBlendʡShellMaterialʡάʲʡVrayShellac
		--Blend֧ max׼ʡVRay׼
		--άʲ֧ max׼ʡVRay׼ʡBlendʡShellMaterial
		--Vray֧ ׼Vray׼
		--Shellac֧ ׼Vray׼
			NoMat=#()
	
		
			I=1
	
		    j=selection
			
			b=100/j.count as float
		
		
			
		
		
		
			for Obj in selection do 
			(
				EN_pb2.value=i*b
				i=i+1
				--жǷ޲
				if obj.material==undefined  then
				(
					
					err=true
					append NoMat obj
					
					)
	--------------------------------------------------------------------------------------------------------------------------
			--׼
				if classof Obj.material==Standardmaterial then
				(
					if obj.material.diffusemap!=undefined then
					(
						try(Obj.material.name=(getFilenameFile Obj.material.diffuseMap.fileName))catch()
					)
				
					
				)
	---------------------------------------------------------------------------------------------------------------------------
				--Vray׼
				if classof Obj.material==VRayMtl then
				(
					if obj.material.texmap_diffuse!=undefined then
					(
						
						try(Obj.material.name=(getFilenameFile Obj.material.texmap_diffuse.fileName))catch()
						)
					)
	----------------------------------------------------------------------------------------------------------------------------
				--Shell_Material  
				if classof obj.material==Shell_Material then
				(
					----------------
					if classof obj.material.bakedmaterial==Standardmaterial then
					(
						if obj.material.bakedmaterial.diffusemap!=undefined then
						( 
							try(Obj.material.bakedmaterial.name=(getFilenameFile Obj.material.bakedmaterial.diffuseMap.fileName))catch()
	
							)
						)
					----------------
					if classof obj.material.originalmaterial==Standardmaterial then
					(
						if obj.material.originalmaterial.diffusemap!=undefined then
						( 
							try(Obj.material.originalmaterial.name=(getFilenameFile Obj.material.originalmaterial.diffuseMap.fileName))catch()
	
							)
						)
					---------------Vray
						if classof obj.material.bakedmaterial==VRayMtl then
					(
						if obj.material.bakedmaterial.texmap_diffuse!=undefined then
						( 
							try(Obj.material.bakedmaterial.name=(getFilenameFile Obj.material.bakedmaterial.texmap_diffuse.fileName))catch()
	
							)
						)
					----------------Vray
					if classof obj.material.originalmaterial==VRayMtl then
					(
						if obj.material.originalmaterial.texmap_diffuse!=undefined then
						( 
							try(Obj.material.originalmaterial.name=(getFilenameFile Obj.material.originalmaterial.texmap_diffuse.fileName))catch()
	
							)
						)
					---------------
					)
	---------------------------------------------------------------------------------------------------------------------
				--blend  
				if classof obj.material==Blend then
				(
	
					----׼
					if classof obj.material.map1==Standardmaterial then
					(
						if obj.material.map1.diffusemap!=undefined then
						( 
							try(Obj.material.map1.name=(getFilenameFile Obj.material.map1.diffuseMap.fileName))catch()
	
							)
						)	
				
					----
					if classof obj.material.map2==Standardmaterial then
					(
						if obj.material.map2.diffusemap!=undefined then
						( 
							try(Obj.material.map2.name=(getFilenameFile Obj.material.map2.diffuseMap.fileName))catch()
	
							)
						)
					----Vray
					if classof obj.material.map1==VRayMtl then
					(
						if obj.material.map1.texmap_diffuse!=undefined then
						( 
							try(Obj.material.map1.name=(getFilenameFile Obj.material.map1.texmap_diffuse.fileName))catch()
	
							)
						)	
				
					----
					if classof obj.material.map2==VRayMtl then
					(
						if obj.material.map2.texmap_diffuse!=undefined then
						( 
							try(Obj.material.map2.name=(getFilenameFile Obj.material.map1.texmap_diffuse.fileName))catch()
	
							)
						)
					----
							)
	------------------------------------------------------------------------------------------------------------------------
				--Shellac
							
				if classof obj.material==Shellac then
				(
					--׼
					if classof obj.material.basematerial==standardmaterial then
					(
						if obj.material.basematerial.diffusemap!=undefined then
						(
							try(Obj.material.basematerial.name=(getFilenameFile Obj.material.basematerial.diffusemap.fileName))catch()
							)
						)
						----------
					if classof obj.material.ShellacMaterial==standardmaterial then
					(
						if obj.material.ShellacMaterial.diffusemap!=undefined then
						(
							try(Obj.material.ShellacMaterial.name=(getFilenameFile Obj.material.ShellacMaterial.diffusemap.fileName))catch()
							)
						)
					--Vray
					---------------------------------
					if classof obj.material.basematerial==VRayMtl then
					(
						if obj.material.basematerial.texmap_diffuse!=undefined then
						(
							try(Obj.material.basematerial.name=(getFilenameFile Obj.material.basematerial.texmap_diffuse.fileName))catch()
							)
						)
						----------
					if classof obj.material.ShellacMaterial==VRayMtl then
					(
						if obj.material.ShellacMaterial.texmap_diffuse!=undefined then
						(
							try(Obj.material.ShellacMaterial.name=(getFilenameFile Obj.material.ShellacMaterial.texmap_diffuse.fileName))catch()
							)
						)
						
						
					
					)
	--------------------------------------------------------------------------------------------------------------------------
				--Vray
				if classof obj.material==VRayMtlWrapper then
				(
					
					----------
					--׼
					if classof obj.material.baseMtl==standardmaterial then
					(
						if obj.material.baseMtl.diffusemap!=undefined then
						(
							try(Obj.material.baseMtl.name=(getFilenameFile Obj.material.baseMtl.diffusemap.fileName))catch()
							)
						)
						----------
					
					--Vray
					---------------------------------
					if classof obj.material.baseMtl==VRayMtl then
					(
						if obj.material.baseMtl.texmap_diffuse!=undefined then
						(
							try(Obj.material.baseMtl.name=(getFilenameFile Obj.material.baseMtl.texmap_diffuse.fileName))catch()
							)
						)
						----------
					
						
					)
					
	-----------------------------------------------------------------------------------------------------------------------------
				--άʲ
			    if classof obj.material==Multimaterial then
				(
					for i=1 to obj.material.count do
					(
						--׼
						if classof Obj.material[i]==Standardmaterial then
						(
							if obj.material[i].diffusemap!=undefined then
							(
								try(Obj.material[i].name=(getFilenameFile Obj.material[i].diffuseMap.fileName))catch()
							)
									
						)
						--vray
						if classof obj.material[i]==VRayMtl then
						(
							if obj.material[i].texmap_diffuse!=undefined then
							(
								try(Obj.material[i].name=(getFilenameFile Obj.material[i].texmap_diffuse.fileName))catch()
							)
							)
						
						
								--Shell_Material  
						if classof obj.material[i]==Shell_Material then
						(
							----------------
							if classof obj.material[i].bakedmaterial==Standardmaterial then
							(
								if obj.material[i].bakedmaterial.diffusemap!=undefined then
								( 
									try(Obj.material[i].bakedmaterial.name=(getFilenameFile Obj.material[i].bakedmaterial.diffuseMap.fileName))catch()
	
									)
								)
							----------------
							if classof obj.material[i].originalmaterial==Standardmaterial then
							(
								if obj.material[i].originalmaterial.diffusemap!=undefined then
								( 
									try(Obj.material[i].originalmaterial.name=(getFilenameFile Obj.material[i].originalmaterial.diffuseMap.fileName))catch()
	
									)
								)
							---------------Vray
								if classof obj.material[i].bakedmaterial==VRayMtl then
							(
								if obj.material[i].bakedmaterial.texmap_diffuse!=undefined then
								( 
									try(Obj.material[i].bakedmaterial.name=(getFilenameFile Obj.material[i].bakedmaterial.texmap_diffuse.fileName))catch()
	
									)
								)
							----------------Vray
							if classof obj.material[i].originalmaterial==VRayMtl then
							(
								if obj.material[i].originalmaterial.texmap_diffuse!=undefined then
								( 
									try(Obj.material[i].originalmaterial.name=(getFilenameFile Obj.material[i].originalmaterial.texmap_diffuse.fileName))catch()
	
									)
								)
							---------------
							)
						--Blend 
						--blend  
						if classof obj.material[i]==Blend then
						(
	
							----׼
							if classof obj.material[i].map1==Standardmaterial then
							(
								if obj.material[i].map1.diffusemap!=undefined then
								( 
									try(Obj.material[i].map1.name=(getFilenameFile Obj.material[i].map1.diffuseMap.fileName))catch()
	
									)
								)	
						
							----
							if classof obj.material[i].map2==Standardmaterial then
							(
								if obj.material[i].map2.diffusemap!=undefined then
								( 
									try(Obj.material[i].map2.name=(getFilenameFile Obj.material[i].map1.diffuseMap.fileName))catch()
	
									)
								)
							----Vray
							if classof obj.material[i].map1==VRayMtl then
							(
								if obj.material[i].map1.texmap_diffuse!=undefined then
								( 
									try(Obj.material[i].map1.name=(getFilenameFile Obj.material[i].map1.texmap_diffuse.fileName))catch()
	
									)
								)	
						
							----
							if classof obj.material[i].map2==VRayMtl then
							(
								if obj.material[i].map2.texmap_diffuse!=undefined then
								( 
									try(Obj.material[i].map2.name=(getFilenameFile Obj.material[i].map1.texmap_diffuse.fileName))catch()
	
									)
								)
							----
									)
							
							)
				
						)
				
				
			
			)
	------------------------------------------------------------------------------------------------------------------
			--޲
			
		if err =true then
		(	if nomat.count!=0 then
			(
					select NoMat
				messagebox"The operation is complete, rename the model contains objects without Material" 
			)
					
		else
	
			messagebox"The operation is completed" 
			)
		
	)
	on btn7 pressed do
	(
		messagebox "You can being developed"
			
		)
	on btn16 pressed do
	(
		NoMat=#()
			
	
			for i in selection do 
			(
				if i.material==undefined  then
				(
					
					err=true
					append NoMat i
					
					)
				else
					(
				meditmaterials[1]=i.material
				i.material=meditmaterials[1]
				i.name=uniqueName meditmaterials[1].name as string
						
					)
			)
		
			
			
			if nomat.count!=0 then
			(
				select NoMat
				messagebox"Renamed model contains objects without Material" 
			)
					
				
			
	
		)
	on btn17 pressed do
	(
		macros.run "Tools" "RenameObjects"
	)
	on btn30 pressed do
	(
		-------------
			lbl_Process.text=""
			tex=""
			ttext=""
			err
			NoText=#()
			ChMappingDict = ChMappingDictStruct()
			ChineseDictFileName = "Dict.txt"
		------------ֵǷ---------
			ExsitFile=GetFilenamePath(GetSourceFileName(ChineseDictFileName))+ChineseDictFileName
			if doesFileExist ExsitFile==false then
			(
				messagebox "Dictionary file does not exist! Please check"title:"Dictionary error"
				return false
				)
		------------
			ChineseDictFileStream = OpenFile (GetFilenamePath(GetSourceFileName()) + ChineseDictFileName )
	
			while not Eof ChineseDictFileStream  do
			(
				lbl_Process.text="Reading dictionary file.."
				tempLine = ReadLine ChineseDictFileStream
				dictArray = FilterString tempLine " "
				if dictArray.Count >= 2 do
				( 
					tempValue = dictArray[1]
					tempKeys =  dictArray[2]
					for i = 1 to tempKeys.Count do
					(
						tempKey = tempKeys[i]
						ChMappingDict.Add tempKey tempValue
					)
				)
			)
			Close ChineseDictFileStream
			theMaps = getClassInstances BitmapTexture
			theProxy=getclassInstances Vrayproxy
			theVrayHDRI=getclassInstances VrayHDRI
			theWebfile=getclassinstances target_Light
			theVrayIES=getclassinstances vrayies
			--TextureVrayProxy
			theMaps=themaps+theproxy
			for m in 1 to themaps.count do 
			(
				tex=""				
				try(lbl_Process.text="Checking for file"+getfilenamefile theMaps[m].filename as string)catch()
				try(CN_Name=getFilenameFile theMaps[m].filename)catch()
				if theMaps[m].filename!=undefined then
				(
					for i =1 to CN_Name.count do 
				(
					ttext=ChMappingDict.Get CN_Name[i] as string
					
					if ttext=="undefined"then
					(
						if CN_Name[i]!=" "then
						(
							err=true
							append NoText CN_Name[i]
							)
						
						
						
						)
					)
				
					
					
					)
				
				)
			--HDRI--------------
			for m in 1 to theVrayHDRI.count do
			(
				if theVrayHDRI[m].HDRIMapName!=undefined then
				(
					lbl_Process.text="Checking for file"+getfilenamefile theVrayHDRI[m].HDRIMapName as string
					CN_Name=getfilenamefile theVrayHDRI[m].HDRIMapName
					for i in 1 to CN_Name.count do 
					(
						ttext=ChMappingDict.Get CN_Name[i] as string
						if ttext=="undefined"then
						(
							
							if CN_Name[i]!=" "then
							(
								err=true
								append NoText CN_Name[i]
								)
							)
						)
					)
				
				)
			--WebIES------------------
			for m in 1 to theWebfile.count do 
			(
				if theWebfile[m].webfile!=undefined then
				(
					lbl_Process.text="Checking for file"+getfilenamefile theWebfile[m].webfile as string
					CN_Name=getfilenamefile theWebfile[m].webfile
					for i in 1 to CN_Name.count do 
					(
						ttext=ChMappingDict.Get CN_Name[i] as string
						if ttext=="undefined"then
						(
							if CN_Name[i]!=" "then
							(
								err=true
								append Notext CN_Name[i]
								)
							)
						)
					)
				)
			--VrayIES------------------------------
			for m in 1 to theVrayIES.count do 
			(
				if TheVrayIES[m].ies_file!=undefined then
				(
					lbl_Process.text="Checking for file"+getfilenamefile TheVrayIES[m].ies_file as string
					CN_Name=getfilenamefile TheVrayIES[m].ies_file
					for i in 1 to CN_Name.count do 
					(
						ttext=ChMappingDict.Get CN_Name[i] as string
						if ttext=="undefined"then
						(
							if CN_Name[i]!=" "then
							(
								err=true
								append Notext CN_Name[i]
								)
							)
						)
					)
				)
			if err=true then
			(
				SaveText=#()
				if notext.count<1 then
				(
				messagebox "ֵOK"title:"ʾ"
				lbl_Process.text="ֵOK,Խת"
					)
				else
				(
						
				t="" as string
				SaveText=makeUniqueArray Notext
				for i =1 to SaveText.count do 
				(
					te=SaveText[i]as string
					t=t+te+" "
					
					)
				
				
	
				messagebox (t+SaveText.count as string+"ֵвڣֶӣȱ屣"+GetFilenamePath(GetSourceFileName())+"NOTEXT.TXT")title:"ʾ"
				lbl_Process.text=t+"ڣ"
				file= GetFilenamePath(GetSourceFileName())+"NOTEXT.TXT"
				if doesFileExist file==false then
				(
					createFile "NOTEXT.TXT"
					)
					f=fopen file "r+"
					if f==undefined then
					(
						try(createFile "NOTEXT.TXT")catch()
						f=fopen file "r+"
						)
					if f==undefined then
					(
						messagebox "Create a file error"title:"prompt"
						return false
						)
						
				try(WriteString f t)catch(messagebox"Write error")
				fclose f
	
	
					)
				)
		)
	on btn_Collect_Browser pressed do
	(
			rf=getSavePath caption:"my title" 
			if rf!=undefined then
			(
				edt_Collect_Text.text=rf
				)
			)
	on tt pressed do
	(
		---------ͼΪƴ
		if edt_R_FilePath.text==""then
		(
			messagebox "Choose Save Path"
			return false
			)
		if doesFileExist edt_R_FilePath.text ==false then
		(
			messagebox "Invalid save path"
			return false
			)
		
		
		tex as string
		tex=""
		ttext=""
		ConvertFinish=false
		ChMappingDict = ChMappingDictStruct()
		ChineseDictFileName = "Dict.txt"
		------------ֵǷ---------
		ExsitFile=GetFilenamePath(GetSourceFileName(ChineseDictFileName))+ChineseDictFileName
		if doesFileExist ExsitFile==false then
		(
			messagebox "ֵļڣ飡"title:"ֵ"
			return false
			)
		------------
		ChineseDictFileStream = OpenFile (GetFilenamePath(GetSourceFileName()) + ChineseDictFileName )
		while not Eof ChineseDictFileStream  do
		(
			lbl_Process.text="ڶȡֵļ.."
			tempLine = ReadLine ChineseDictFileStream
			dictArray = FilterString tempLine " "
			if dictArray.Count >= 2 do
			( 
				tempValue = dictArray[1]
				tempKeys =  dictArray[2]
				j=1	
				b=100/tempKeys.Count as float
				for i = 1 to tempKeys.Count do
				(
					EN_pb1.value=i*b
					j=j+1
					tempKey = tempKeys[i]
					ChMappingDict.Add tempKey tempValue
					)
				)
			)	
		Close ChineseDictFileStream
	----------------λͼת-------------------------------
		theMaps = getClassInstances BitmapTexture
		j=1	
		b=100/theMaps.count as float
		for m in 1 to theMaps.count do
		(	if theMaps[m].filename!=undefined then
			(
				try(lbl_Process.text="ת"+getfilenamefile theMaps[m].filename as string)catch()
				EN_pb2.value=j*b
				j=j+1
				tex=""
				ttext=""
				try(FullPathName=(theMaps[m].filename))catch()
				try(testName=(getFilenameFile theMaps[m].filename))catch()
				if testName!=undefined then
				(
					for i = 1 to testName.Count do 
					(
						ttext=ChMappingDict.Get testName[i]as string
						if ttext=="undefined" then tex=tex+" "else tex=tex+ttext
						)
				
					)	
				)
			--ļ·
			FilePath=edt_R_FilePath.text+"\\"
			----ļ
			try(newFilename = FilePath + tex as string + getFilenameType FullPathName)catch()
			--ʱ
			--messagebox themaps[m].filename
			if  newfilename!=""then
			(
				local BM_Count
				try(BM_Count =(getfiles newFilename).count)catch((BM_Count=0))
				if BM_Count!=0 then
				(
					local ex=false
					Exsit=CompareTexture FullPathName newFilename
					case Exsit of
					(
						True:
						(
							local ifl_1
							local ilf_2
							ifl_1=""
							ifl_2=""
							Se=usedmaps( theMaps[m])
							if Se.count>0 then
							(
								for c in 1 to Se.count do 
								(
									ifl_1=""
									ifl_2=""
									try(iflName=(getfilenamefile se[c]))catch()
									if iflname!=undefined then
									(
										for a =1 to iflname.count do
										(
											ifl_1=ChMappingDict.Get iflName[a]as string
											if ifl_1=="undefined"then ifl_2=ifl_2+" "else ifl_2=ifl_2+ifl_1
											)
										)
									try(SePath=FilePath+"\\"+ifl_2+getfilenametype Se[c])catch()
									copyfile Se[c] SePath
									)
							
								)
							try(newFilename = FilePath + tex as string + getFilenameType FullPathName)catch()
							theMaps[m].filename = newFilename
							--д־
							if fullpathname!=undefined then
							(
								ol=getfilenamefile FullPathName
								ne=getfilenamefile newFilename
								WriteLog ol ne
								)	
							)
						False:
						(
							a=random 1 9999 as string
							--t=tmr.time as string						
							num="_New"+a
							try(newFilename = FilePath + tex as string + num as string+ getFilenameType FullPathName)catch()
							try(copyfile FullPathName(FilePath+ tex as string + num as string+getfilenametype FullPathName))catch()
							theMaps[m].filename = newFilename
							--д־
							if fullpathname!=undefined then
							(
								ol=getfilenamefile FullPathName
								ne=getfilenamefile newFilename
								WriteLog ol ne
								)									
							
							
							)
						)
					)
				if BM_Count==0 then
				(
					local ifl_1
					local ilf_2
					ifl_1=""
					ifl_2=""
					Se=usedmaps( theMaps[m])
					if Se.count>0 then
					(
						for c in 1 to Se.count do 
						(
							ifl_1=""
							ifl_2=""
							try(iflName=(getfilenamefile se[c]))catch()
							if iflname!=undefined then
							(
								for a =1 to iflname.count do
								(
									ifl_1=ChMappingDict.Get iflName[a]as string
									if ifl_1=="undefined"then ifl_2=ifl_2+" "else ifl_2=ifl_2+ifl_1
									)
								)
							try(SePath=FilePath+"\\"+ifl_2+getfilenametype Se[c])catch()
							copyfile Se[c] SePath
							)
					
						)
					try(newFilename = FilePath + tex as string + getFilenameType FullPathName)catch()
					try(copyfile FullPathName(FilePath+ tex as string+getfilenametype FullPathName))catch()
					try(theMaps[m].filename = newFilename)catch()
					--д־
					if fullpathname!=undefined then
					(
						ol=getfilenamefile FullPathName
						ne=getfilenamefile newFilename
						WriteLog ol ne
						)
					)
					
				)
			
			
		
			)
				
		theProxy=getClassInstances VrayProxy
		j=1	
		b=100/theProxy.count as float
		if chk_enproxy.checked==true then
		(
		for m in 1 to theProxy.count do 
		(
			if theProxy[m].filename!=undefined then
			(
				try(lbl_Process.text="ת"+getfilenamefile theProxy[m].filename as string)catch()
				EN_pb2.value=j*b
				j=j+1
				tex=""
				ttext=""
				try(FullPathName=(theProxy[m].filename))catch()
				try(testName=(getFilenameFile theProxy[m].filename))catch()
				if testName!=undefined then
				(
					for i = 1 to testName.Count do 
					(
						ttext=ChMappingDict.Get testName[i]as string
						if ttext=="undefined" then tex=tex+" "else tex=tex+ttext
						)
					
					)
			)
			SaveFilePath=edt_R_FilePath.text+"\\"
			try(newFilename = SaveFilePath + tex as string + getFilenameType FullPathName)catch()
			local Pro
			try(Pro=getfiles newFilename.count)catch(Pro=0)
			--if (getfiles newFilename).count!=0 then
			if Pro!=0 then
			(
				Exsit=CompareFiles FullPathName newFilename
				case Exsit of
				(
					True:
					(
						try(theProxy[m].filename=newFilename)catch()
						)
					False:
					(
						a=random 1 9999
						a="_New"+a as string
						newFilename=SavefilePath+tex+a+getFilenameType FullPathName
						try(copyfile FullPathName(newFilename))catch()
						try(theProxy[m].filename=newFilename)catch()
						)
					)
				
				
				)
			if Pro==0 then
			(
				
				try(copyfile FullPathName(newFilename))catch()
				try(theProxy[m].filename=newFilename)catch()
				)
			
			)
			)
		-------------------VrayHDRIת---------------------
		theHDRI=getclassinstances vrayhdri	
		j=1	
		b=100/theHDRI.count as float
		for m in 1 to theHDRI.count do
		(
			if theHDRI[m].HDRIMapName!=undefined then
			(
				lbl_Process.text="ת"+getfilenamefile theHDRI[m].HDRIMapName as string
				EN_pb2.value=j*b
				tex=""
				ttext=""
				FullPathName=theHDRI[m].HDRIMapName
				testName=getfilenamefile theHDRI[m].HDRIMapName
				if testName!=undefined then
				(
					for i in 1 to testName.count do
					(
						ttext=ChMappingDict.Get testName[i]as string
						if ttext=="undefined"then tex=tex+" "else tex=tex+ttext
						)
					)
			
				
				)
			SaveFilePath=edt_R_FilePath.text+"\\"
			try(newFilename = SaveFilePath + tex as string + getFilenameType FullPathName)catch()
			if (getfiles newFilename).count!=0 then
			(
				Exsit=CompareFiles FullPathName newFilename
				case Exsit of 
				(
					true:
					(
						theHDRI[m].HDRIMapName=newFilename
						)
					false:
					(
						a=random 1 9999
						a="_New"+a as string
						newFilename=SavefilePath+tex+a+getFilenameType FullPathName
						copyfile FullPathName newFileName
						theHDRI[m].HDRIMapName=newFilename
						
						)
					)
				)
			if (getfiles newFilename).count==0 then
			(
				copyfile FullPathName newFileName
				theHDRI[m].HDRIMapName=newFilename
				)
			)
		----------------------WebIESת---------------------
		theWebfile=getclassinstances target_Light
		j=1	
		b=100/theWebfile.count as float
		for m in 1 to theWebfile.count do 
		(
			if theWebfile[m].webfile!=undefined then
			(
				lbl_Process.text="Converting"+getfilenamefile theWebfile[m].webfile as string
				EN_pb2.value=j*b
				tex=""
				ttext=""
				FullPathName=theWebfile[m].webfile
				testName=getfilenamefile theWebfile[m].webfile
				if testName!=undefined then
				(
					for i in 1 to testName.count do
					(
						ttext=ChMappingDict.Get testName[i]as string
						if ttext=="undefined"then tex=tex+" "else tex=tex+ttext
						)
					)				
				)
			SaveFilePath=edt_R_FilePath.text+"\\"
			try(newFilename = SaveFilePath + tex as string + getFilenameType FullPathName)catch()
			if (getfiles newFilename).count!=0 then
			(
				Exsit=CompareFiles FullPathName newFilename
				case Exsit of
				(
					True:
					(
						theWebfile[m].webfile=newFilename
						)
					False:
					(
						a=random 1 9999
						a="_New"+a as string
						newFilename=SavefilePath+tex+a+getFilenameType FullPathName
						copyfile FullPathName newFileName
						theWebfile[m].webfile=newFilename
						)
					)
				)
			if (getfiles newFilename).count==0 then
			(
				copyfile FullPathName newFileName
				theWebfile[m].webfile=newFilename
				)
			)
			---------------------------VrayIESת-------------------------------------------
		TheVrayIES=getclassinstances VRayIES
		j=1	
		for m in 1 to theVrayIES.count do
		(
			if TheVrayIES[m].ies_file!=undefined then
			(
				lbl_Process.text="Converting"+getfilenamefile TheVrayIES[m].ies_file as string
				EN_pb2.value=j*b
				tex=""
				ttext=""
				FullPathName=TheVrayIES[m].ies_file
				testName=getfilenamefile TheVrayIES[m].ies_file
				if testName!=undefined then
				(
					for i in 1 to testName.count do
					(
						ttext=ChMappingDict.Get testName[i]as string
						if ttext=="undefined"then tex=tex+" "else tex=tex+ttext
						)
					)				
				)
			SaveFilePath=edt_R_FilePath.text+"\\"
			try(newFilename = SaveFilePath + tex as string + getFilenameType FullPathName)catch()
			if (getfiles newFilename).count!=0 then
			(
				Exsit=CompareFiles FullPathName newFilename
				case Exsit of
				(
					True:
					(
						TheVrayIES[m].ies_file=newFilename
						)
					False:
					(
						a=random 1 9999
						a="_New"+a as string
						newFilename=SavefilePath+tex+a+getFilenameType FullPathName
						copyfile FullPathName newFileName
						TheVrayIES[m].ies_file=newFilename
						)
					)
				)
			if (getfiles newFilename).count==0 then
			(
				copyfile FullPathName newFileName
				TheVrayIES[m].ies_file=newFilename
				)
				
				
			)
		
			
		messagebox "The conversion is complete"
			lbl_Process.text="The conversion is complete"
			en_pb1.value=0
			en_pb2.value=0
		)
	on btn41 pressed do
	(
		local s1
		local s2
		local b1
		local b2
		if edt_Collect_Text.text==""then
		(
			messagebox "Choose Save Path"
			return false
			)
		if doesFileExist edt_Collect_Text.text ==false then
		(
			messagebox "Invalid save path"
			return false
			)
		CollectPath=edt_Collect_Text.text
		Obj=selection
		s1=1
		b1=100/Obj.count as float
		SaveModel=for i in selection collect i
		
			
		savenodes SaveModel(CollectPath+"\\"+"Collect.max")
			
		for i in 1 to Obj.count do 
		(
			EN_pb1.value=s1*b1
			s1=s1+1
			theMap=usedmaps(Obj[i])
			s2=1
			b2=100/theMap.count as float
			for j in 1 to theMap.count do
			(
				EN_pb2.value=s2*b2
				s2=s2+1
				NewtheMaps=CollectPath+"\\"+getfilenamefile theMap[j]+getfilenametype theMap[j]
				copyfile theMap[j] NewtheMaps
				
				)
			
			
			)
		messagebox "Complete collection"
				
			------
	
	
	
	
	
		)
	on btn_R_Browse pressed do
	(
	rf=getSavePath caption:"my title" 
	if rf!=undefined then
	(
		edt_R_FilePath.text=rf
		)
		
		)
	on btn67 pressed do
	(
	TheVrayIES=getclassinstances VRayIES
			j=1	
		a="ߣǹ"as string	
		b="QQ:182888983" as string
		c="Email:hwthwh@hotmail.com" as string
		s="\n"
		messagebox (a + s + b + s + c )title:"About Script"
		)
	on btn68 pressed do
	(   ShellLaunch "http://www.scriptsays.com/ """
		)
	on Collect_Map pressed do
	(
		if edt_bmp.text==""then
		(
			messagebox "Choose Save Path"
			return false
			)
		if doesFileExist edt_bmp.text ==false then
		(
			messagebox "Invalid save path"
			return false
			)
		AssignPath=edt_bmp.text
		
		Amaps=getClassInstances BitmapTexture
		j=1	
		b=100/AMaps.count as float
		for m in 1 to Amaps.count do
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="Collecting map..."
			case chk_b_subFolder.checked of
			(
				true:
				(
					ba="Maps"
					pa="\\"+ba
					pa=Assignpath+pa
					makedir pa
						Se=usedmaps(Amaps[m])
						if Se.count>0 then
						(
							for i in 1 to Se.count do 
							(
								
								try(SePath=AssignPath+"\\"+ba+"\\"+getfilenamefile Se[i]+getfilenametype Se[i])catch()
								copyfile Se[i] SePath
								)
							)
					)
				
				false:
				(
						Se=usedmaps(Amaps[m])
						if Se.count>0 then
						(
							for i in 1 to Se.count do 
							(
								try(SePath=AssignPath+"\\"+getfilenamefile Se[i]+getfilenametype Se[i])catch()
								copyfile Se[i] SePath
								)
						
							)
					)
					
					
				)
			
			--messagebox newfilepath
			try(copyfile Amaps[m].filename(NewfilePath))catch()
			
			
			)
		AProxy=GetClassInstances Vrayproxy
		j=1
		b=100/Aproxy.count as float
		for m in 1 to AProxy.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="Collecting Vray Proxy..."
			case chk_b_subfolder.checked of
			(
				true:
				(
					ba="VrayMesh"
					pa="\\"+ba
					pa=Assignpath+pa
					makedir pa
					try(NewfilePath=AssignPath+"\\"+ba+"\\"+GetfilenameFile AProxy[m].filename+Getfilenametype AProxy[m].filename)catch()
					)
				false:
				(
					try(NewfilePath=AssignPath+"\\"+GetfilenameFile AProxy[m].filename+Getfilenametype AProxy[m].filename)catch()
	
					)
				)
			--messagebox newfilepath
			try(copyfile AProxy[m].filename(NewfilePath))catch()
			)
		--------------------------------------------------------------
		AHDRI=GetClassInstances Vrayhdri
		j=1
		b=100/AHDRI.count as float
		for m in 1 to AHDRI.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="CollectingVrayHDRI..."
			case chk_b_subFolder.checked of
			(
				true:
				(
					ba="VrayHDRI"
					pa="\\"+ba
					pa=Assignpath+pa
					makedir pa
					try(NewfilePath=AssignPath+"\\"+ba+"\\"+GetfilenameFile AHDRI[m].HDRIMapName+Getfilenametype AHDRI[m].HDRIMapName)catch()
	
					)
				false:
				(
					try(NewfilePath=AssignPath+"\\"+GetfilenameFile AHDRI[m].HDRIMapName+Getfilenametype AHDRI[m].HDRIMapName)catch()
					
					)
				
				)
			try(copyfile AHDRI[m].HDRIMapName(NewfilePath))catch()
			)
		----------------------------------------------	
		AWebfile=GetClassInstances target_Light
		j=1
		b=100/AWebfile.count as float
		for m in 1 to AWebfile.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="CollectingWebFiles..."
	
			case chk_b_subfolder.checked of
			(
				true:
				(
					ba="WebFiles"
					pa="\\"+ba
					pa=Assignpath+pa
					makedir pa
					try(NewfilePath=AssignPath+"\\"+ba+"\\"+GetfilenameFile AWebfile[m].webfile+Getfilenametype AWebfile[m].webfile)catch()
					)
				false:
				(
					try(NewfilePath=AssignPath+"\\"+GetfilenameFile AWebfile[m].webfile+Getfilenametype AWebfile[m].webfile)catch()
					)
				
				
				)
			try(copyfile AWebfile[m].webfile(NewfilePath))catch()
			)
		-------------------------------------------
		AVrayIES=GetClassInstances vrayies
		j=1
		b=100/AVrayIES.count as float
		for m in 1 to AVrayIES.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="CollectingVrayIES..."
			case chk_b_subfolder.checked of
			(
				true:
				(
					ba="WebFiles"
					pa="\\"+ba
					pa=Assignpath+pa
					makedir pa
					try(NewfilePath=AssignPath+"\\"+ba+"\\"+GetfilenameFile AVrayIES[m].ies_file+Getfilenametype AVrayIES[m].ies_file)catch()
					)
				false:
				(
					try(NewfilePath=AssignPath+"\\"+GetfilenameFile AVrayIES[m].ies_file+Getfilenametype AVrayIES[m].ies_file)catch()
					)
				
				
				)
			try(copyfile AVrayIES[m].ies_file(NewfilePath))catch()
			)
		----------------------------------------------------
		
		
		messagebox "Complete collection"		
		)
	on BMP_B pressed do
	(
			local rf
			rf=getSavePath caption:"my title" 
			if rf!=undefined then
			(
				edt_bmp.text=rf
				)
			)
------------------------------------------------------ָͼ------------------------------------
	on BMP_A pressed do
	(
		
		if edt_bmp.text==""then
		(
			messagebox "Choose Save Path"
			return false
			)
		if doesFileExist edt_bmp.text ==false then
		(
			messagebox "Invalid save path"
			return false
			)
		AssignPath=edt_bmp.text
		Amaps=getClassInstances BitmapTexture
		j=1	
		b=100/AMaps.count as float
		for m in 1 to Amaps.count do
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="Is designated map..."
			case chk_b_subfolder.checked of
			(
				true:
				(
					pa=""
					ba="Maps"
					pa="\\"+ba
					try(NewfilePath=AssignPath+pa+"\\"+getfilenamefile Amaps[m].filename + getfilenametype Amaps[m].filename)catch()
					)
				false:
				(
					try(NewfilePath=AssignPath+"\\"+getfilenamefile Amaps[m].filename + getfilenametype Amaps[m].filename)catch()
					)
				)
			--messagebox newfilepath
			try(AMaps[m].filename = NewfilePath)catch()
			
			
			)
		AVrayProxy=getClassInstances vrayproxy
		j=1	
		b=100/AVrayProxy.count as float
		for m in 1 to AVrayProxy.count do
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="Vray proxy is specified..."
			case chk_b_subfolder.checked of
			(
				true:
				(
					pa=""
					ba="VrayMesh"
					pa="\\"+ba
					try(NewfilePath=AssignPath+pa+"\\"+getfilenamefile AVrayProxy[m].filename + getfilenametype AVrayProxy[m].filename)catch()
					)
				false:
				(
					try(NewfilePath=AssignPath+"\\"+getfilenamefile AVrayProxy[m].filename + getfilenametype AVrayProxy[m].filename)catch()
					)
				
				)
			--messagebox newfilepath
			try(AVrayProxy[m].filename = NewfilePath)catch()
			
			
			)
		AVrayHDRI=getClassInstances VrayHdri
		j=1	
		b=100/AVrayHDRI.count as float
		for m in 1 to AVrayHDRI.count do
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="It is designatedVrayHDRI..."
			case chk_b_subfolder.checked of
			(
				true:
				(
					pa=""
					ba="VrayHdRI"
					pa="\\"+ba
					try(NewfilePath=AssignPath+pa+"\\"+getfilenamefile AVrayHDRI[m].HDRIMapName + getfilenametype AVrayHDRI[m].HDRIMapName)catch()
					)
				false:
				(
					try(NewfilePath=AssignPath+"\\"+getfilenamefile AVrayHDRI[m].HDRIMapName + getfilenametype AVrayHDRI[m].HDRIMapName)catch()
					)
				
				)
			--messagebox newfilepath
			try(AVrayHDRI[m].HDRIMapName = NewfilePath)catch()
			
			
			)
		AWebfile=GetClassInstances target_Light
		j=1
		b=100/AWebfile.count as float
		for m in 1 to AWebfile.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="It is designatedWebFile..."
			case chk_b_subfolder.checked of
			(
				true:
				(
					pa=""
					ba="WebFiles"
					pa="\\"+ba
					try(NewfilePath=AssignPath+pa+"\\"+GetfilenameFile AWebfile[m].webfile+Getfilenametype AWebfile[m].webfile)catch()
					)
				false:
				(
					try(NewfilePath=AssignPath+"\\"+GetfilenameFile AWebfile[m].webfile+Getfilenametype AWebfile[m].webfile)catch()
					)
				
				
				)
			try(AWebfile[m].webfile = NewfilePath)catch()
			
			)
		----------------------------------------
		AVrayIES=GetClassInstances vrayies
		j=1
		b=100/AVrayIES.count as float
		for m in 1 to AVrayIES.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			lbl_Process.text="It is designatedVrayIES..."
			case chk_b_subfolder.checked of
			(
				true:
				(
					pa=""
					ba="WebFiles"
					pa="\\"+ba
					try(NewfilePath=AssignPath+pa+"\\"+GetfilenameFile  AVrayIES[m].ies_file+Getfilenametype  AVrayIES[m].ies_file)catch()
					)
				false:
				(
					try(NewfilePath=AssignPath+"\\"+GetfilenameFile  AVrayIES[m].ies_file+Getfilenametype  AVrayIES[m].ies_file)catch()
					)
				
				
				)
			try( AVrayIES[m].ies_file = NewfilePath)catch()
			
			)
	
		messagebox "Specifying the Finishing"		
				
	
	
	
	
	
		)
	on btn_MissRefresh pressed do
	(
		UpdateMissMaps()
		Lbl_MissFiles.text=lab_text
		MissList.items= item_text
		MissList.height=240
		
			
		)
	on btn_MissSearch pressed do
	(
		local Search=#()
		local b=#()
		if edt_MissBrowser.text==""then
		(
			messagebox "Select search path"
			return false
			)
		if doesFileExist edt_MissBrowser.text ==false then
		(
			messagebox "Invalid search path"
			return false
			)
		Apath=edt_MissBrowser.text
		Apath=Apath+"\\"
		case chk_subFolder.checked of
		(
			true:
			(
				Search=GetAllFiles  Apath "*"
				Search=makeUniqueArray Search
				)
			false:(Search=GetNoneSubFolderFiles  Apath "*")
			)
			
		----------maps
		Amaps=getclassinstances bitmaptexture
		j=1	
		b=100/AMaps.count as float
		for m in 1 to amaps.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			if Amaps[m].filename!=undefined then
			(
				if DoesFileExist Amaps[m].filename==false then
				(
					
					old=getfilenamefile Amaps[m].filename
					lbl_Process.text="Match is"+old
					for n in 1 to Search.count do 
					(
						
						new=getfilenamefile Search[n]
						if old==new then
						(
							try(AMaps[m].filename =Search[n])catch()
							lbl_Process.text=old+"Match success"
							exit
							)
						
						)
					
					)
				
				)
			)
		--------------vrayproxy
		AProxy=GetClassInstances VrayProxy
		j=1
		b=100/AProxy.count as float
		for m in 1 to AProxy.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			if AProxy[m].filename!=undefined then
			(
				if DoesFileExist AProxy[m].filename==false then
				(
					old=getfilenamefile AProxy[m].filename
					lbl_Process.text="Match is"+old
					for n in 1 to Search.count do 
					(
						new=getfilenamefile Search[n]
						if old==new then 
						(
							try(AProxy[m].filename=Search[n])catch()
							lbl_process.text=old+"Match success"
							exit
							)
						)
					)
				)
			)
		---------------------------
		
		AHDRI=getclassinstances vrayhdri
		j=1
		b=100/AHDRI.count as float
		for m in 1 to AHDRI.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			if AHDRI[m].HDRIMapName!=undefined then
			(
				if DoesFileExist AHDRI[m].HDRIMapName==false then
					(
						old=getfilenamefile AHDRI[m].HdriMapName
						lbl_Process.text="Match is"+old
						for n in 1 to Search.count do 
						(
							new=getfilenamefile Search[n]
							if old==new then
							(
								try(AHDRI[m].HDRIMapName=Search[n])catch()
								lbl_process.text=old+"Match success"
								exit
								)
							)
						)
				)
			)
		------------------------------------------
		
		AIESWebFile=getclassinstances target_Light
		j=1
		b=100/AIESWebFile.count as float
		for m in 1 to AIESWebFile.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			if AIESWebFile[m].webfile!=undefined then
			(
				if DoesFileExist AIESWebFile[m].webfile==false then
					(
						old=getfilenamefile AIESWebFile[m].webfile
						lbl_Process.text="Match is"+old
						for n in 1 to Search.count do 
						(
							new=getfilenamefile Search[n]
							if old==new then
							(
								try(AIESWebFile[m].webfile=Search[n])catch()
								lbl_process.text=old+"Match success"
								exit
								)
							)
						)
				)
			)
		--------------------------------------------
		AVrayIES=getclassinstances vrayies
		j=1
		b=100/AVrayIES.count as float
		for m in 1 to AVrayIES.count do 
		(
			EN_pb2.value=j*b
			j=j+1
			if AVrayIES[m].ies_file!=undefined then
			(
				if DoesFileExist AVrayIES[m].ies_file==false then
					(
						old=getfilenamefile AVrayIES[m].ies_file
						lbl_Process.text="Match is"+old
						for n in 1 to Search.count do 
						(
							new=getfilenamefile Search[n]
							if old==new then
							(
								try(AVrayIES[m].ies_file=Search[n])catch()
								lbl_process.text=old+"Match success"
								exit
								)
							)
						)
				)
			)
		lbl_Process.text=""
		-----------------------update bitmap-------
		UpdateMissMaps()
		Lbl_MissFiles.text=lab_text
		MissList.items= item_text
		MissList.height=240
		
		
	
	
		
		)
	on btn_MissBrowser pressed do
	(
		rf=getSavePath caption:"my title" 
		if rf!=undefined then
		(
			edt_MissBrowser.text=rf
			)
		)
	on MissList doubleClicked sel do
	(
		MissMaps_Info=MissList.selected
		MissMaps_Info=getfilenamefile MissMaps_Info
		messagebox MissMaps_Info
	
	)
)




if FloaterExampleFloater != undefined do
	(
	closerolloutfloater FloaterExampleFloater
	)

--CreateDialog Tools_A 410 460				
FloaterExampleFloater = newRolloutFloater "WMagicTools1.5.6" 410 460
addRollout Tools_A FloaterExampleFloater

--Fntest()
